from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  pipefail = 3
  inherit_errexit = 4
  nullglob = 5
  verbose_errexit = 6
  noexec = 7
  xtrace = 8
  verbose = 9
  noglob = 10
  noclobber = 11
  posix = 12
  vi = 13
  emacs = 14
  interactive = 15
  hashall = 16
  failglob = 17
  extglob = 18
  nocasematch = 19
  eval_unsafe_arith = 20
  _allow_command_sub = 21
  _allow_process_sub = 22
  dynamic_scope = 23
  redefine_module = 24
  _running_trap = 25
  _running_hay = 26
  _no_debug_trap = 27
  _no_err_trap = 28
  strict_argv = 29
  strict_arith = 30
  strict_array = 31
  strict_control_flow = 32
  strict_errexit = 33
  strict_nameref = 34
  strict_word_eval = 35
  strict_tilde = 36
  strict_glob = 37
  parse_at = 38
  parse_proc = 39
  parse_func = 40
  parse_brace = 41
  parse_bracket = 42
  parse_equals = 43
  parse_paren = 44
  parse_ysh_string = 45
  parse_triple_quote = 46
  simple_word_eval = 47
  dashglob = 48
  command_sub_errexit = 49
  process_sub_fail = 50
  xtrace_rich = 51
  xtrace_details = 52
  sigpipe_status_ok = 53
  redefine_proc_func = 54
  parse_at_all = 55
  parse_backslash = 56
  parse_backticks = 57
  parse_dollar = 58
  parse_ignored = 59
  parse_sh_arith = 60
  parse_dparen = 61
  parse_dbracket = 62
  parse_bare_word = 63
  simple_echo = 64
  simple_eval_builtin = 65
  simple_test_builtin = 66
  expand_aliases = 67
  lastpipe = 68
  progcomp = 69
  histappend = 70
  hostcomplete = 71
  cmdhist = 72
  assoc_expand_once = 73
  autocd = 74
  cdable_vars = 75
  cdspell = 76
  checkhash = 77
  checkjobs = 78
  checkwinsize = 79
  complete_fullquote = 80
  direxpand = 81
  dirspell = 82
  dotglob = 83
  execfail = 84
  extdebug = 85
  extquote = 86
  force_fignore = 87
  globasciiranges = 88
  globstar = 89
  gnu_errfmt = 90
  histreedit = 91
  histverify = 92
  huponexit = 93
  interactive_comments = 94
  lithist = 95
  localvar_inherit = 96
  localvar_unset = 97
  login_shell = 98
  mailwarn = 99
  no_empty_cmd_completion = 100
  nocaseglob = 101
  progcomp_alias = 102
  promptvars = 103
  restricted_shell = 104
  shift_verbose = 105
  sourcepath = 106
  xpg_echo = 107
  ARRAY_SIZE = 108

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.pipefail',
  4: 'option.inherit_errexit',
  5: 'option.nullglob',
  6: 'option.verbose_errexit',
  7: 'option.noexec',
  8: 'option.xtrace',
  9: 'option.verbose',
  10: 'option.noglob',
  11: 'option.noclobber',
  12: 'option.posix',
  13: 'option.vi',
  14: 'option.emacs',
  15: 'option.interactive',
  16: 'option.hashall',
  17: 'option.failglob',
  18: 'option.extglob',
  19: 'option.nocasematch',
  20: 'option.eval_unsafe_arith',
  21: 'option._allow_command_sub',
  22: 'option._allow_process_sub',
  23: 'option.dynamic_scope',
  24: 'option.redefine_module',
  25: 'option._running_trap',
  26: 'option._running_hay',
  27: 'option._no_debug_trap',
  28: 'option._no_err_trap',
  29: 'option.strict_argv',
  30: 'option.strict_arith',
  31: 'option.strict_array',
  32: 'option.strict_control_flow',
  33: 'option.strict_errexit',
  34: 'option.strict_nameref',
  35: 'option.strict_word_eval',
  36: 'option.strict_tilde',
  37: 'option.strict_glob',
  38: 'option.parse_at',
  39: 'option.parse_proc',
  40: 'option.parse_func',
  41: 'option.parse_brace',
  42: 'option.parse_bracket',
  43: 'option.parse_equals',
  44: 'option.parse_paren',
  45: 'option.parse_ysh_string',
  46: 'option.parse_triple_quote',
  47: 'option.simple_word_eval',
  48: 'option.dashglob',
  49: 'option.command_sub_errexit',
  50: 'option.process_sub_fail',
  51: 'option.xtrace_rich',
  52: 'option.xtrace_details',
  53: 'option.sigpipe_status_ok',
  54: 'option.redefine_proc_func',
  55: 'option.parse_at_all',
  56: 'option.parse_backslash',
  57: 'option.parse_backticks',
  58: 'option.parse_dollar',
  59: 'option.parse_ignored',
  60: 'option.parse_sh_arith',
  61: 'option.parse_dparen',
  62: 'option.parse_dbracket',
  63: 'option.parse_bare_word',
  64: 'option.simple_echo',
  65: 'option.simple_eval_builtin',
  66: 'option.simple_test_builtin',
  67: 'option.expand_aliases',
  68: 'option.lastpipe',
  69: 'option.progcomp',
  70: 'option.histappend',
  71: 'option.hostcomplete',
  72: 'option.cmdhist',
  73: 'option.assoc_expand_once',
  74: 'option.autocd',
  75: 'option.cdable_vars',
  76: 'option.cdspell',
  77: 'option.checkhash',
  78: 'option.checkjobs',
  79: 'option.checkwinsize',
  80: 'option.complete_fullquote',
  81: 'option.direxpand',
  82: 'option.dirspell',
  83: 'option.dotglob',
  84: 'option.execfail',
  85: 'option.extdebug',
  86: 'option.extquote',
  87: 'option.force_fignore',
  88: 'option.globasciiranges',
  89: 'option.globstar',
  90: 'option.gnu_errfmt',
  91: 'option.histreedit',
  92: 'option.histverify',
  93: 'option.huponexit',
  94: 'option.interactive_comments',
  95: 'option.lithist',
  96: 'option.localvar_inherit',
  97: 'option.localvar_unset',
  98: 'option.login_shell',
  99: 'option.mailwarn',
  100: 'option.no_empty_cmd_completion',
  101: 'option.nocaseglob',
  102: 'option.progcomp_alias',
  103: 'option.promptvars',
  104: 'option.restricted_shell',
  105: 'option.shift_verbose',
  106: 'option.sourcepath',
  107: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  readonly = 10
  local = 11
  declare = 12
  typeset = 13
  export_ = 14
  true_ = 15
  false_ = 16
  try_ = 17
  read = 18
  echo = 19
  printf = 20
  mapfile = 21
  readarray = 22
  cd = 23
  pushd = 24
  popd = 25
  dirs = 26
  pwd = 27
  source = 28
  umask = 29
  ulimit = 30
  wait = 31
  jobs = 32
  fg = 33
  bg = 34
  shopt = 35
  complete = 36
  compgen = 37
  compopt = 38
  compadjust = 39
  compexport = 40
  getopts = 41
  builtin = 42
  command = 43
  type = 44
  hash = 45
  help = 46
  history = 47
  alias = 48
  unalias = 49
  bind = 50
  append = 51
  write = 52
  json = 53
  json8 = 54
  pp = 55
  hay = 56
  haynode = 57
  module = 58
  use = 59
  error = 60
  failed = 61
  fork = 62
  forkwait = 63
  fopen = 64
  shvar = 65
  ctx = 66
  runproc = 67
  boolstatus = 68
  test = 69
  bracket = 70
  push_registers = 71
  is_main = 72
  cat = 73
  ARRAY_SIZE = 74

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.readonly',
  11: 'builtin.local',
  12: 'builtin.declare',
  13: 'builtin.typeset',
  14: 'builtin.export_',
  15: 'builtin.true_',
  16: 'builtin.false_',
  17: 'builtin.try_',
  18: 'builtin.read',
  19: 'builtin.echo',
  20: 'builtin.printf',
  21: 'builtin.mapfile',
  22: 'builtin.readarray',
  23: 'builtin.cd',
  24: 'builtin.pushd',
  25: 'builtin.popd',
  26: 'builtin.dirs',
  27: 'builtin.pwd',
  28: 'builtin.source',
  29: 'builtin.umask',
  30: 'builtin.ulimit',
  31: 'builtin.wait',
  32: 'builtin.jobs',
  33: 'builtin.fg',
  34: 'builtin.bg',
  35: 'builtin.shopt',
  36: 'builtin.complete',
  37: 'builtin.compgen',
  38: 'builtin.compopt',
  39: 'builtin.compadjust',
  40: 'builtin.compexport',
  41: 'builtin.getopts',
  42: 'builtin.builtin',
  43: 'builtin.command',
  44: 'builtin.type',
  45: 'builtin.hash',
  46: 'builtin.help',
  47: 'builtin.history',
  48: 'builtin.alias',
  49: 'builtin.unalias',
  50: 'builtin.bind',
  51: 'builtin.append',
  52: 'builtin.write',
  53: 'builtin.json',
  54: 'builtin.json8',
  55: 'builtin.pp',
  56: 'builtin.hay',
  57: 'builtin.haynode',
  58: 'builtin.module',
  59: 'builtin.use',
  60: 'builtin.error',
  61: 'builtin.failed',
  62: 'builtin.fork',
  63: 'builtin.forkwait',
  64: 'builtin.fopen',
  65: 'builtin.shvar',
  66: 'builtin.ctx',
  67: 'builtin.runproc',
  68: 'builtin.boolstatus',
  69: 'builtin.test',
  70: 'builtin.bracket',
  71: 'builtin.push_registers',
  72: 'builtin.is_main',
  73: 'builtin.cat',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

